# $Revision: 1.42 $, $Date: 2006/09/29 21:25:58 $
# TODO
# - IMPORTANT: resolve permission problem for webserver access to /usr/sbin/fping
# - generated config does not always match the used webserver vhost (don't autogenerate it at all?)
# - finish -cgi and main files, afaik templates/ needed only by -cgi
# - use .patch not decruft()
# - IMPORTANT: use other user than root for daemon (uid=stats perhaps)
%include	/usr/lib/rpm/macros.perl
Summary:	Smokeping - a latency grapher that uses rrdtool
Summary(pl):	Smokeping - narzdzie do tworzenia wykresw opnie sieci
Name:		smokeping
Version:	2.0.9
Release:	1
License:	GPL v2
Group:		Networking/Utilities
Source0:	http://people.ee.ethz.ch/~oetiker/webtools/smokeping/pub/%{name}-%{version}.tar.gz
# Source0-md5:	512c0bc38176451df7d664050b1283d9
Source1:	%{name}.init
Source2:	%{name}.conf
Source3:	%{name}-config
Source4:	%{name}-lighttpd.conf
URL:		http://people.ee.ethz.ch/~oetiker/webtools/smokeping/
BuildRequires:	perl-tools-pod
BuildRequires:	rpm-perlprov >= 4.1-13
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	rrdtool
BuildRequires:	sed >= 4.0
Requires(post):	sed >= 4.0
Requires(post,preun):	/sbin/chkconfig
Requires:	fping
Requires:	rc-scripts
Requires:	rrdtool >= 1.2
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/%{name}
%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_wwwconfdir	%{_webapps}/%{_webapp}
%define		_cgi_bindir	%{_prefix}/share/%{name}

%description
SmokePing is a ICMP latency logging and graphing system. It consists
of a daemon process which organizes the latency measurements and a CGI
which presents the graphs with interesting smoke-like effects.

%description -l pl
Smokeping jest narzdziem do tworzenia wykresw aktywnoci sieci.
Uywajc pakietw ICMP zapisuje czas odpowiedzi poszczeglnych hostw
i wywietla je w postaci czytelnego wykresu.

%package cgi
Summary:	CGI webinterface for smokeping
Summary(pl):	Interfejs WWW (CGI) do smokepinga
Group:		Applications/WWW
Requires:	%{name} = %{version}-%{release}
Requires:	webapps

%description cgi
CGI webinterface for smokeping.

%description cgi -l pl
Interfejs WWW (CGI) do smokepinga.

%prep
%setup -q

decruft() { %{__sed} -i -e "s|$1|$2|g" `grep -lr "$1" *` ;}

# eliminate Tobi's quirks
decruft /usr/sepp/bin %{_bindir}

decruft /home/oetiker/data/projects/AADJ-smokeping/dist/etc	%{_sysconfdir}
decruft /home/oetiker/data/projects/AADJ-smokeping/dist/lib	%{_datadir}/%{name}

# rrdtool package goes into standard perl tree
decruft '^use lib .*rrdtool.*;' ''

# there's no SpeedyCGI for apache2? use regular perl...
decruft %{_bindir}/speedy %{_bindir}/perl

# working config in wrong location
decruft "etc/config.dist" "%{_sysconfdir}/config"

sed -i -e 's@^#!/usr/bin/perl-5.8.4@#!/usr/bin/perl@' bin/smokeping.dist
sed -i -e 's#use lib qw(lib);#use lib qw(%{_datadir}/%{name});#' bin/smokeping.dist

%build
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/rc.d/init.d,%{_sysconfdir},%{_wwwconfdir},%{_sbindir}} \
	$RPM_BUILD_ROOT{%{_datadir}/%{name},%{_sharedstatedir}/%{name}/{img,rrd},%{_cgi_bindir}} \
	$RPM_BUILD_ROOT%{_mandir}/man1

install etc/basepage.html.dist $RPM_BUILD_ROOT%{_sysconfdir}/basepage.html
install etc/config.dist $RPM_BUILD_ROOT%{_sysconfdir}
#install etc/config-echoping.dist $RPM_BUILD_ROOT%{_sysconfdir}/config-echoping
install etc/smokemail.dist $RPM_BUILD_ROOT%{_sysconfdir}/smokemail
install bin/smokeping.dist $RPM_BUILD_ROOT%{_sbindir}/smokeping
install bin/tSmoke.dist $RPM_BUILD_ROOT%{_sbindir}/tSmoke
install htdocs/smokeping.cgi.dist $RPM_BUILD_ROOT%{_cgi_bindir}/smokeping.cgi
cp -r lib/* $RPM_BUILD_ROOT%{_datadir}/%{name}
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT%{_wwwconfdir}/httpd.conf
install %{SOURCE2} $RPM_BUILD_ROOT%{_wwwconfdir}/apache.conf
install %{SOURCE4} $RPM_BUILD_ROOT%{_wwwconfdir}/lighttpd.conf
install %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/config
install doc/*.1 $RPM_BUILD_ROOT%{_mandir}/man1

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = "1" ]; then

firstgate=`route -n |awk '$1=="0.0.0.0" && $4 ~ /G/ {print $2}' | head -n 1`
echo "
+ gateway
 menu   = Default Gateway
 title  = Default Gateway Router
 host   = $firstgate

+ dns
 menu   = DNS Servers
 title  = Domain Name Servers
        " >> %{_sysconfdir}/config
for dns in `awk '$1 ~ /^nameserver/ {print $2}' /etc/resolv.conf | LC_ALL=C sort -u` ; do
((dnscnt++))
echo "++ dns$dnscnt
  menu  = DNS Server $dnscnt
  title = Domain Name Server $dnscnt
  host  = $dns
        " >> %{_sysconfdir}/config
done

[ "$HOSTNAME" ] && %{__sed} -i -e "s|localhost|$HOSTNAME|g" %{_sysconfdir}/config

fi

/sbin/chkconfig --add %{name}
%service %{name} restart

%preun
if [ "$1" = 0 ]; then
	%service %{name} stop
	/sbin/chkconfig --del %{name}
fi

%triggerin cgi -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun cgi -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin cgi -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}

%triggerun cgi -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%triggerin -- lighttpd
%webapp_register lighttpd %{_webapp}

%triggerun -- lighttpd
%webapp_unregister lighttpd %{_webapp}

%triggerpostun -- %{name} < 2.0.5-0.3
# we put trigger on main package, because we can't trigger in new package
# this will create .rpmnew files when one installs -cgi package. but that's more than okay
if [ -f /etc/httpd/httpd.conf/99_%{name}.conf.rpmsave ]; then
	install -d %{_wwwconfdir}
	mv -f /etc/httpd/httpd.conf/99_%{name}.conf.rpmsave %{_wwwconfdir}/httpd.conf
fi

%service -q httpd reload

%banner -e %{name} << EOF
The CGI program is available as %{name}-cgi package.
EOF

%files
%defattr(644,root,root,755)
%doc CHANGES CONTRIBUTORS COPYRIGHT README TODO doc/*.txt doc/*.html
%attr(755,root,root) %{_sbindir}/*
%{_datadir}/smokeping
%exclude %{_datadir}/smokeping/*.cgi
%{_mandir}/man1/*.1*
%dir %{_sysconfdir}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/*
%attr(754,root,root) /etc/rc.d/init.d/*
%dir %{_sharedstatedir}/%{name}
%{_sharedstatedir}/%{name}/rrd
%dir %attr(775,root,http) %{_sharedstatedir}/%{name}/img

%files cgi
%defattr(644,root,root,755)
%dir %attr(750,root,http) %{_wwwconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_wwwconfdir}/apache.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_wwwconfdir}/httpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_wwwconfdir}/lighttpd.conf
%attr(755,root,root) %{_cgi_bindir}/*.cgi

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: smokeping.spec,v $
Revision 1.42  2006/09/29 21:25:58  glen
- update webapp triggers due apache1 package split

Revision 1.41  2006/09/01 10:18:47  kosmo
-  md5 updated :)

Revision 1.40  2006/09/01 10:17:11  kosmo
- updated to 2.0.9

Revision 1.39  2006/06/16 15:27:57  blues
- rel.5 - add lighttp config

Revision 1.38  2006/05/21 22:16:18  glen
- rel 4

Revision 1.37  2006/03/13 23:14:32  glen
- use %service

Revision 1.36  2006/02/03 16:47:58  baggins
- release 3

Revision 1.35  2006/02/03 16:40:54  glen
- apache-base in webapp trigger

Revision 1.34  2006/01/03 10:56:06  glen
- mark items definately need to be fixed as important

Revision 1.33  2005/12/28 16:23:20  glen
- programs moved to sbin
- img is directory, mark so in filelist
- use rpm-perlprov to generate perl deps

Revision 1.32  2005/12/28 15:07:19  blues
- rel. 2 with fixed default config (keep old way of working). STBR

Revision 1.31  2005/12/26 00:22:51  qboosh
- pl for -cgi

Revision 1.30  2005/12/25 22:29:57  glen
- use webapps
- ac-main contains incompatible version, rel 1

Revision 1.29  2005/11/30 02:03:58  zbyniu
- up to 2.0.5, cleanups

Revision 1.28  2005/10/28 21:07:27  areq
- fix

Revision 1.27  2005/10/27 09:22:25  blues
- smokeping libs are not in perl dirs

Revision 1.26  2005/10/26 13:56:02  blues
- started 2.0.x series - this is needed for current rrdtool

Revision 1.24  2005/10/26 12:34:17  gotar
- upgraded to 1.43

Revision 1.23  2005/09/04 16:56:35  megabajt
- BR: sed >= 4.0

Revision 1.22  2005/07/17 21:32:17  gotar
- upgraded to 1.42

Revision 1.21  2005/05/30 17:32:41  gotar
- upgraded to 1.41, STBR

Revision 1.20  2005/05/13 19:26:24  zbyniu
- up to 1.40, proper perl name

Revision 1.19  2005/05/04 19:45:50  darekr
- proper License

Revision 1.18  2005/02/01 21:27:37  paszczus
- updated to 1.38

Revision 1.17  2005/01/15 11:18:49  darekr
- updated to 1.37

Revision 1.16  2005/01/07 11:26:38  adamg
- updated to 1.36
- BuildRequires: rrdtool

Revision 1.15  2004/12/17 17:47:22  darekr
- updated to 1.34

Revision 1.14  2004/12/01 01:27:35  zbyniu
- added PreReq: rc-scripts and Requires(): /sbin/chkconfig for daemon

Revision 1.13  2004/10/31 16:25:46  paladine
- spaces->tabs
- formatting

Revision 1.12  2004/10/16 10:01:17  gotar
- fixed summaries, BR: perl-tools-pod,
- fixed paths: httpd config directory, FHS compliance (use datadir
  instead of libdir for perl modules, sharedstatedir instead of httpd
  home for logs and images, proper permission for images directory),
- fixed hardcoded paths (http://www.greenkey.net/~curtis/rpm/src/),
- chmod +x cgi, chmod o-x initscript,
- fixed init script and apache config file; do not mess in the main,
- added working default config,
- run %post only for install, not for upgrade,
- PLD-style installs, cosmetics,
- release 1, STBR.

Revision 1.11  2004/08/23 12:42:40  pawelb
- up to 1.31

Revision 1.10  2004/07/21 22:09:56  pawelb
- created post scripts
- TODO: make proper paths in configfile
- not tested

Revision 1.9  2004/07/21 19:21:41  qboosh
- cleanups, missing dirs

Revision 1.8  2004/07/20 23:17:57  domelu
- cosmetics (url)
- spaces -> tabs

Revision 1.7  2004/07/20 22:50:35  domelu
- proper group

Revision 1.6  2004/07/20 22:46:09  pawelb
- NFY
- do not hit me :)

Revision 1.5  2004/07/20 22:15:00  ankry
- restored changelog

Revision 1.4  2004/07/20 22:12:51  ankry
- adapterized, R/BR: perl-base, other cosmetics

Revision 1.3  2004/07/20 22:06:53  pawelb
- cosmetic #2 :/

Revision 1.2  2004/07/20 21:57:18  pawelb
- cosmetic

Revision 1.1  2004/07/20 21:38:24  pawelb
- init
- NFY
